//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
//
//	Utils.h
//
//	Utility functions.
//
//\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

#pragma once

//  __#Defines________________________________________________________________________
//  __#Headers________________________________________________________________________
//  __#Protos_________________________________________________________________________
//  ___Macros_________________________________________________________________________

#if DEBUG == TRUE
	#define mAssert(x)		((x) ? (void)0 	: SysBreakStr("\pAssert triggered"))
#else
	#define mAssert(x)		((void)0)
#endif

//slick macros get upper left and lower right points of Rects
#define mTopLeft(r)		(((Point *)&(r))[0])
#define mBotRight(r)	(((Point *)&(r))[1])

//returns rectangle describing structure region of a window; coordinates are global
#define mWindStructRect(w)	((*(((WindowPeek)w)->strucRgn))->rgnBBox)

//  __ Enums__________________________________________________________________________
//  __ Typedefs_______________________________________________________________________
//  __ Extern Globals_________________________________________________________________
extern RGBColor		blackRGB;
extern RGBColor		grayRGB;
extern RGBColor		whiteRGB;

//  __ Protos__________________________________________________________________

void ToolBoxInit( void );
void WaitForQuit( void );
Boolean EnviroCheck( void );
void ShowStopAlert(StringPtr pascalMessage);
void GetAppName(char *pascalName);
void InitRandomNumbers( void );
unsigned short RandomRange( unsigned short range );
void LocalToGlobalRect(Rect *r);
void GlobalToLocalRect(Rect *r);
void CenterRectInRect(Rect *rect1, Rect *rect2);
void CenterWindowInRect(WindowPtr wind, Rect *boundRect, Boolean oneThird);
GDHandle GetMaxIntersectDevice(Rect globalRect);
GDHandle GetLargestAreaDevice( void );
short CountAvailableDevices( void );

//string utils
long CLen(char *s);
short PLen(StringPtr s);
char *Pas2c(unsigned char *str);
unsigned char *C2pas(char *str);
char *CCpy(char *dest, char *src);
unsigned char *PCpy(StringPtr dest, StringPtr src);
void CWrite( short x, short y, ConstStr255Param s );
void ParamAString( ConstStr255Param theStr );

